]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
libjpeg-compat: Drop package
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007-2020 IPFire Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 # If you update the version don't forget to update backupiso and add it to core update
28 VERSION="2.25" # Version number
29 CORE="155" # Core Level (Filename)
30 SLOGAN="www.ipfire.org" # Software slogan
31 CONFIG_ROOT=/var/ipfire # Configuration rootdir
32 MAX_RETRIES=1 # prefetch/check loop
33 BUILD_IMAGES=1 # Flash and Xen Downloader
34 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
35
36 # Information from Git
37 GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
38 GIT_TAG="$(git tag | tail -1)" # Git Tag
39 GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
40
41 TOOLCHAINVER=20200924
42
43 ###############################################################################
44 #
45 # Beautifying variables & presentation & input output interface
46 #
47 ###############################################################################
48
49 # Remember if the shell is interactive or not
50 if [ -t 0 ] && [ -t 1 ]; then
51 INTERACTIVE=true
52 else
53 INTERACTIVE=false
54 fi
55
56 # Sets or adjusts pretty formatting variables
57 resize_terminal() {
58 ## Screen Dimentions
59 # Find current screen size
60 COLUMNS=$(tput cols)
61
62 # When using remote connections, such as a serial port, stty size returns 0
63 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
64 COLUMNS=80
65 fi
66
67 # Measurements for positioning result messages
68 OPTIONS_WIDTH=20
69 TIME_WIDTH=12
70 STATUS_WIDTH=8
71 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
72 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
73
74 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
75 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
76 }
77
78 # Initially setup terminal
79 resize_terminal
80
81 # Call resize_terminal when terminal is being resized
82 trap "resize_terminal" WINCH
83
84 # Define color for messages
85 BOLD="\\033[1;39m"
86 DONE="\\033[1;32m"
87 SKIP="\\033[1;34m"
88 WARN="\\033[1;35m"
89 FAIL="\\033[1;31m"
90 NORMAL="\\033[0;39m"
91
92 # New architecture variables
93 HOST_ARCH="$(uname -m)"
94
95 PWD=$(pwd)
96 BASENAME=$(basename $0)
97
98 # Debian specific settings
99 if [ ! -e /etc/debian_version ]; then
100 FULLPATH=`which $0`
101 else
102 if [ -x /usr/bin/realpath ]; then
103 FULLPATH=`/usr/bin/realpath $0`
104 else
105 echo "ERROR: Need to do apt-get install realpath"
106 exit 1
107 fi
108 fi
109
110 # This is the directory where make.sh is in
111 export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
112
113 LOGFILE=$BASEDIR/log/_build.preparation.log
114 export LOGFILE
115 DIR_CHK=$BASEDIR/cache/check
116 mkdir $BASEDIR/log/ 2>/dev/null
117
118 system_processors() {
119 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
120 }
121
122 system_memory() {
123 local key val unit
124
125 while read -r key val unit; do
126 case "${key}" in
127 MemTotal:*)
128 # Convert to MB
129 echo "$(( ${val} / 1024 ))"
130 break
131 ;;
132 esac
133 done < /proc/meminfo
134 }
135
136 configure_build() {
137 local build_arch="${1}"
138
139 if [ "${build_arch}" = "default" ]; then
140 build_arch="$(configure_build_guess)"
141 fi
142
143 case "${build_arch}" in
144 x86_64)
145 BUILDTARGET="${build_arch}-unknown-linux-gnu"
146 CROSSTARGET="${build_arch}-cross-linux-gnu"
147 BUILD_PLATFORM="x86"
148 CFLAGS_ARCH="-m64 -mtune=generic -fstack-clash-protection -fcf-protection"
149 ;;
150
151 i586)
152 BUILDTARGET="${build_arch}-pc-linux-gnu"
153 CROSSTARGET="${build_arch}-cross-linux-gnu"
154 BUILD_PLATFORM="x86"
155 CFLAGS_ARCH="-march=i586 -mtune=generic -fomit-frame-pointer"
156 ;;
157
158 aarch64)
159 BUILDTARGET="${build_arch}-unknown-linux-gnu"
160 CROSSTARGET="${build_arch}-cross-linux-gnu"
161 BUILD_PLATFORM="arm"
162 CFLAGS_ARCH="-fstack-clash-protection"
163 ;;
164
165 armv7hl)
166 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
167 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
168 BUILD_PLATFORM="arm"
169 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
170 ;;
171
172 armv5tel)
173 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
174 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
175 BUILD_PLATFORM="arm"
176 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
177 RUSTFLAGS="-Ccodegen-units=1"
178 ;;
179
180 *)
181 exiterror "Cannot build for architure ${build_arch}"
182 ;;
183 esac
184
185 # Check if the QEMU helper is available if needed.
186 if qemu_is_required "${build_arch}"; then
187 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
188
189 if [ -n "${qemu_build_helper}" ]; then
190 QEMU_TARGET_HELPER="${qemu_build_helper}"
191 else
192 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
193 fi
194 fi
195
196 BUILD_ARCH="${build_arch}"
197 TOOLS_DIR="/tools_${BUILD_ARCH}"
198
199 # Enables hardening
200 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
201
202 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
203 CXXFLAGS="${CFLAGS}"
204
205 # Determine parallelism
206 # We assume that each process consumes about
207 # 128MB of memory. Therefore we find out how
208 # many processes fit into memory.
209 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
210 local cpu_max=$(( ${SYSTEM_PROCESSORS} + 1 ))
211
212 local parallelism
213 if [ ${mem_max} -lt ${cpu_max} ]; then
214 parallelism=${mem_max}
215 else
216 parallelism=${cpu_max}
217 fi
218
219 # Use this as default PARALLELISM
220 DEFAULT_PARALLELISM="${parallelism}"
221
222 # Limit lauched ninja build jobs to computed parallel value.
223 NINJAJOBS="${parallelism}"
224
225 # Compression parameters
226 # We use mode 8 for reasonable memory usage when decompressing
227 # but with overall good compression
228 XZ_OPT="-8"
229
230 # We try to use as many cores as possible
231 XZ_OPT="${XZ_OPT} -T0"
232
233 # We need to limit memory because XZ uses too much when running
234 # in parallel and it isn't very smart in limiting itself.
235 # We allow XZ to use up to 70% of all system memory.
236 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
237
238 # XZ memory cannot be larger than 2GB on 32 bit systems
239 case "${build_arch}" in
240 i*86|armv*)
241 if [ ${xz_memory} -gt 2048 ]; then
242 xz_memory=2048
243 fi
244 ;;
245 esac
246
247 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
248 }
249
250 configure_build_guess() {
251 case "${HOST_ARCH}" in
252 x86_64)
253 echo "x86_64"
254 ;;
255 i?86)
256 echo "i586"
257 ;;
258
259 aarch64)
260 echo "aarch64"
261 ;;
262
263 armv7*|armv6*|armv5*)
264 echo "armv5tel"
265 ;;
266
267 *)
268 exiterror "Cannot guess build architecture"
269 ;;
270 esac
271 }
272
273 stdumount() {
274 umount $BASEDIR/build/sys 2>/dev/null;
275 umount $BASEDIR/build/dev/shm 2>/dev/null;
276 umount $BASEDIR/build/dev/pts 2>/dev/null;
277 umount $BASEDIR/build/dev 2>/dev/null;
278 umount $BASEDIR/build/proc 2>/dev/null;
279 umount $BASEDIR/build/install/mnt 2>/dev/null;
280 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
281 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
282 umount $BASEDIR/build/usr/src/config 2>/dev/null;
283 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
284 umount $BASEDIR/build/usr/src/html 2>/dev/null;
285 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
286 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
287 umount $BASEDIR/build/usr/src/log 2>/dev/null;
288 umount $BASEDIR/build/usr/src/src 2>/dev/null;
289 umount $BASEDIR/build/usr/src 2>/dev/null;
290 umount $BASEDIR/build/tmp 2>/dev/null;
291 }
292
293 now() {
294 date -u "+%s"
295 }
296
297 format_runtime() {
298 local seconds=${1}
299
300 if [ ${seconds} -ge 3600 ]; then
301 printf "%d:%02d:%02d\n" \
302 "$(( seconds / 3600 ))" \
303 "$(( seconds % 3600 / 60 ))" \
304 "$(( seconds % 3600 % 60 ))"
305 elif [ ${seconds} -ge 60 ]; then
306 printf "%d:%02d\n" \
307 "$(( seconds / 60 ))" \
308 "$(( seconds % 60 ))"
309 else
310 printf "%d\n" "${seconds}"
311 fi
312 }
313
314 print_line() {
315 local line="$@"
316
317 printf "%-${LINE_WIDTH}s" "${line}"
318 }
319
320 _print_line() {
321 local status="${1}"
322 shift
323
324 if ${INTERACTIVE}; then
325 printf "${!status}"
326 fi
327
328 print_line "$@"
329
330 if ${INTERACTIVE}; then
331 printf "${NORMAL}"
332 fi
333 }
334
335 print_headline() {
336 _print_line BOLD "$@"
337 }
338
339 print_error() {
340 _print_line FAIL "$@"
341 }
342
343 print_package() {
344 local name="${1}"
345 shift
346
347 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
348 local options="$@"
349
350 local string="${name}"
351 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
352 string="${string} (${version})"
353 fi
354
355 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
356 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
357 }
358
359 print_runtime() {
360 local runtime=$(format_runtime $@)
361
362 if ${INTERACTIVE}; then
363 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
364 else
365 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
366 fi
367 }
368
369 print_status() {
370 local status="${1}"
371
372 local color="${!status}"
373
374 if ${INTERACTIVE}; then
375 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
376 else
377 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
378 fi
379 }
380
381 print_build_stage() {
382 print_headline "$@"
383
384 # end line
385 printf "\n"
386 }
387
388 print_build_summary() {
389 local runtime=$(format_runtime $@)
390
391 print_line "*** Build finished in ${runtime}"
392 print_status DONE
393 }
394
395 exiterror() {
396 stdumount
397 for i in `seq 0 7`; do
398 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
399 losetup -d /dev/loop${i} 2>/dev/null
400 fi;
401 done
402
403 # Dump logfile
404 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
405 echo # empty line
406
407 local line
408 while read -r line; do
409 echo " ${line}"
410 done <<< "$(tail -n30 ${LOGFILE})"
411 fi
412
413 echo # empty line
414
415 local line
416 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
417 print_error "${line}"
418 print_status FAIL
419 done
420
421 exit 1
422 }
423
424 prepareenv() {
425 # Are we running the right shell?
426 if [ -z "${BASH}" ]; then
427 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
428 fi
429
430 if [ -z "${BASH_VERSION}" ]; then
431 exiterror "Not running BASH shell."
432 fi
433
434 # Trap on emergency exit
435 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
436
437 # Checking if running as root user
438 if [ $(id -u) -ne 0 ]; then
439 exiterror "root privileges required for building"
440 fi
441
442 # Checking for necessary temporary space
443 print_line "Checking for necessary space on disk $BASE_DEV"
444 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
445 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
446 if (( 2048000 > $BASE_ASPACE )); then
447 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
448 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
449 print_status FAIL
450 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
451 fi
452 else
453 print_status DONE
454 fi
455
456 # Set umask
457 umask 022
458
459 # Set LFS Directory
460 LFS=$BASEDIR/build
461
462 # Setup environment
463 set +h
464 LC_ALL=POSIX
465 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS NINJAJOBS
466 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
467
468 # Make some extra directories
469 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
470 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
471 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
472 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}} 2>/dev/null
473
474 if [ "${ENABLE_RAMDISK}" = "on" ]; then
475 mkdir -p $BASEDIR/build/usr/src
476 mount -t tmpfs tmpfs -o size=8G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
477
478 mkdir -p ${BASEDIR}/build/tmp
479 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 ${BASEDIR}/build/tmp
480 fi
481
482 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
483
484 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
485 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
486
487 # Make all sources and proc available under lfs build
488 mount --bind /dev $BASEDIR/build/dev
489 mount --bind /dev/pts $BASEDIR/build/dev/pts
490 mount --bind /dev/shm $BASEDIR/build/dev/shm
491 mount --bind /proc $BASEDIR/build/proc
492 mount --bind /sys $BASEDIR/build/sys
493 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
494 mount --bind $BASEDIR/ccache/${BUILD_ARCH} $BASEDIR/build/usr/src/ccache
495 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
496 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
497 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
498 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
499 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
500 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
501 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
502
503 # Run LFS static binary creation scripts one by one
504 export CCACHE_DIR=$BASEDIR/ccache
505 export CCACHE_TEMPDIR="/tmp"
506 export CCACHE_COMPRESS=1
507 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
508
509 # Remove pre-install list of installed files in case user erase some files before rebuild
510 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
511
512 # Prepare string for /etc/system-release.
513 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
514
515 case "${GIT_BRANCH}" in
516 core*|beta?|rc?)
517 system_release="${system_release} - ${GIT_BRANCH}"
518 ;;
519 *)
520 system_release="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
521 ;;
522 esac
523
524 # Append -dirty tag for local changes
525 if [ "$(git status -s | wc -l)" != "0" ]; then
526 system_release="${system_release}-dirty"
527 fi
528
529 # Export variable
530 SYSTEM_RELEASE="${system_release}"
531
532 # Decide on PAKFIRE_TREE
533 case "${GIT_BRANCH}" in
534 core*)
535 PAKFIRE_TREE="stable"
536 ;;
537 master)
538 PAKFIRE_TREE="testing"
539 ;;
540 *)
541 PAKFIRE_TREE="unstable"
542 ;;
543 esac
544
545 # Setup ccache cache size
546 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
547 }
548
549 enterchroot() {
550 # Install QEMU helper, if needed
551 qemu_install_helper
552
553 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
554
555 PATH="${PATH}" chroot ${LFS} env -i \
556 HOME="/root" \
557 TERM="${TERM}" \
558 PS1="${PS1}" \
559 PATH="${PATH}" \
560 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
561 PAKFIRE_TREE="${PAKFIRE_TREE}" \
562 NAME="${NAME}" \
563 SNAME="${SNAME}" \
564 VERSION="${VERSION}" \
565 CORE="${CORE}" \
566 SLOGAN="${SLOGAN}" \
567 TOOLS_DIR="${TOOLS_DIR}" \
568 CONFIG_ROOT="${CONFIG_ROOT}" \
569 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
570 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
571 RUSTFLAGS="${RUSTFLAGS}" \
572 BUILDTARGET="${BUILDTARGET}" \
573 CROSSTARGET="${CROSSTARGET}" \
574 BUILD_ARCH="${BUILD_ARCH}" \
575 BUILD_PLATFORM="${BUILD_PLATFORM}" \
576 CCACHE_DIR=/usr/src/ccache \
577 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
578 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
579 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
580 GOCACHE="/usr/src/ccache/go" \
581 KVER="${KVER}" \
582 XZ_OPT="${XZ_OPT}" \
583 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
584 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
585 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
586 $(fake_environ) \
587 $(qemu_environ) \
588 "$@"
589 }
590
591 entershell() {
592 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
593 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
594 fi
595
596 echo "Entering to a shell inside LFS chroot, go out with exit"
597 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
598
599 if enterchroot bash -i; then
600 stdumount
601 else
602 print_status FAIL
603 exiterror "chroot error"
604 fi
605 }
606
607 lfsmakecommoncheck() {
608 # Script present?
609 if [ ! -f $BASEDIR/lfs/$1 ]; then
610 exiterror "No such file or directory: $BASEDIR/$1"
611 fi
612
613 # Print package name and version
614 print_package $@
615
616 # Check if this package is supported by our architecture.
617 # If no SUP_ARCH is found, we assume the package can be built for all.
618 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
619 # Check if package supports ${BUILD_ARCH} or all architectures.
620 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
621 print_runtime 0
622 print_status SKIP
623 return 1
624 fi
625 fi
626
627 # Script slipped?
628 local i
629 for i in $SKIP_PACKAGE_LIST
630 do
631 if [ "$i" == "$1" ]; then
632 print_status SKIP
633 return 1;
634 fi
635 done
636
637 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
638
639 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
640 MESSAGE="$1\t " download >> $LOGFILE 2>&1
641 if [ $? -ne 0 ]; then
642 exiterror "Download error in $1"
643 fi
644
645 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
646 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
647 if [ $? -ne 0 ]; then
648 exiterror "md5sum error in $1, check file in cache or signature"
649 fi
650
651 return 0 # pass all!
652 }
653
654 lfsmake1() {
655 lfsmakecommoncheck $*
656 [ $? == 1 ] && return 0
657
658 cd $BASEDIR/lfs && env -i \
659 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
660 CCACHE_DIR="${CCACHE_DIR}" \
661 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
662 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
663 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
664 CFLAGS="${CFLAGS}" \
665 CXXFLAGS="${CXXFLAGS}" \
666 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
667 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
668 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
669 make -f $* \
670 TOOLCHAIN=1 \
671 TOOLS_DIR="${TOOLS_DIR}" \
672 CROSSTARGET="${CROSSTARGET}" \
673 BUILDTARGET="${BUILDTARGET}" \
674 BUILD_ARCH="${BUILD_ARCH}" \
675 BUILD_PLATFORM="${BUILD_PLATFORM}" \
676 LFS_BASEDIR="${BASEDIR}" \
677 ROOT="${LFS}" \
678 KVER="${KVER}" \
679 install >> $LOGFILE 2>&1 &
680
681 if ! wait_until_finished $!; then
682 print_status FAIL
683 exiterror "Building $*"
684 fi
685
686 print_status DONE
687 }
688
689 lfsmake2() {
690 lfsmakecommoncheck $*
691 [ $? == 1 ] && return 0
692
693 local PS1='\u:\w$ '
694
695 enterchroot \
696 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
697 make -f $* \
698 LFS_BASEDIR=/usr/src install" \
699 >> ${LOGFILE} 2>&1 &
700
701 if ! wait_until_finished $!; then
702 print_status FAIL
703 exiterror "Building $*"
704 fi
705
706 print_status DONE
707 }
708
709 ipfiredist() {
710 lfsmakecommoncheck $*
711 [ $? == 1 ] && return 0
712
713 local PS1='\u:\w$ '
714
715 enterchroot \
716 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
717 >> ${LOGFILE} 2>&1 &
718
719 if ! wait_until_finished $!; then
720 print_status FAIL
721 exiterror "Packaging $*"
722 fi
723
724 print_status DONE
725 }
726
727 wait_until_finished() {
728 local pid=${1}
729
730 local start_time=$(now)
731
732 # Show progress
733 if ${INTERACTIVE}; then
734 # Wait a little just in case the process
735 # has finished very quickly.
736 sleep 0.1
737
738 local runtime
739 while kill -0 ${pid} 2>/dev/null; do
740 print_runtime $(( $(now) - ${start_time} ))
741
742 # Wait a little
743 sleep 1
744 done
745 fi
746
747 # Returns the exit code of the child process
748 wait ${pid}
749 local ret=$?
750
751 if ! ${INTERACTIVE}; then
752 print_runtime $(( $(now) - ${start_time} ))
753 fi
754
755 return ${ret}
756 }
757
758 fake_environ() {
759 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
760
761 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
762
763 # Fake kernel version, because some of the packages do not compile
764 # with kernel 3.0 and later.
765 env="${env} UTS_RELEASE=${KVER}-ipfire"
766
767 # Fake machine version.
768 env="${env} UTS_MACHINE=${BUILD_ARCH}"
769
770 echo "${env}"
771 }
772
773 qemu_environ() {
774 local env
775
776 # Don't add anything if qemu is not used.
777 if ! qemu_is_required; then
778 return
779 fi
780
781 # Set default qemu options
782 case "${BUILD_ARCH}" in
783 arm*)
784 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
785
786 env="${env} QEMU_CPU=${QEMU_CPU}"
787 ;;
788 esac
789
790 # Enable QEMU strace
791 #env="${env} QEMU_STRACE=1"
792
793 echo "${env}"
794 }
795
796 qemu_is_required() {
797 local build_arch="${1}"
798
799 if [ -z "${build_arch}" ]; then
800 build_arch="${BUILD_ARCH}"
801 fi
802
803 case "${HOST_ARCH},${build_arch}" in
804 x86_64,arm*|x86_64,aarch64|i?86,arm*|i?86,aarch64|i?86,x86_64)
805 return 0
806 ;;
807 *)
808 return 1
809 ;;
810 esac
811 }
812
813 qemu_install_helper() {
814 # Do nothing, if qemu is not required
815 if ! qemu_is_required; then
816 return 0
817 fi
818
819 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
820 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
821 fi
822
823 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
824 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
825 fi
826
827
828 if [ -z "${QEMU_TARGET_HELPER}" ]; then
829 exiterror "QEMU_TARGET_HELPER not set"
830 fi
831
832 # Check if the helper is already installed.
833 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
834 return 0
835 fi
836
837 # Try to find a suitable binary that we can install
838 # to the build environment.
839 local file
840 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
841 # file must exist and be executable.
842 [ -x "${file}" ] || continue
843
844 # Must be static.
845 file_is_static "${file}" || continue
846
847 local dirname="${LFS}$(dirname "${file}")"
848 mkdir -p "${dirname}"
849
850 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
851 return 0
852 done
853
854 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
855 }
856
857 qemu_find_build_helper_name() {
858 local build_arch="${1}"
859
860 local magic
861 case "${build_arch}" in
862 aarch64)
863 magic="7f454c460201010000000000000000000200b700"
864 ;;
865 arm*)
866 magic="7f454c4601010100000000000000000002002800"
867 ;;
868 x86_64)
869 magic="7f454c4602010100000000000000000002003e00"
870 ;;
871 esac
872
873 [ -z "${magic}" ] && return 1
874
875 local file
876 for file in /proc/sys/fs/binfmt_misc/*; do
877 # skip write only register entry
878 [ $(basename "${file}") = "register" ] && continue
879 # Search for the file with the correct magic value.
880 grep -qE "^magic ${magic}$" "${file}" || continue
881
882 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
883
884 [ -n "${interpreter}" ] || continue
885 [ "${interpreter:0:1}" = "/" ] || continue
886 [ -x "${interpreter}" ] || continue
887
888 echo "${interpreter}"
889 return 0
890 done
891
892 return 1
893 }
894
895 file_is_static() {
896 local file="${1}"
897
898 file ${file} 2>/dev/null | grep -q "statically linked"
899 }
900
901 update_language_list() {
902 local path="${1}"
903
904 local lang
905 for lang in ${path}/*.po; do
906 lang="$(basename "${lang}")"
907 echo "${lang%*.po}"
908 done | sort -u > "${path}/LINGUAS"
909 }
910
911 contributors() {
912 local commits name
913
914 git shortlog --summary --numbered | while read -r commits name; do
915 echo "${name}"
916 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
917 }
918
919 update_contributors() {
920 echo -n "Updating list of contributors"
921
922 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
923
924 # Edit contributors into credits.cgi
925 local tmp="$(mktemp)"
926
927 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
928 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
929
930 # Copy back modified content
931 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
932 unlink "${tmp}"
933
934 print_status DONE
935 return 0
936 }
937
938 # Default settings
939 CCACHE_CACHE_SIZE="4G"
940 ENABLE_RAMDISK="auto"
941
942 # Load configuration file
943 if [ -f .config ]; then
944 . .config
945 fi
946
947 # TARGET_ARCH is BUILD_ARCH now
948 if [ -n "${TARGET_ARCH}" ]; then
949 BUILD_ARCH="${TARGET_ARCH}"
950 unset TARGET_ARCH
951 fi
952
953 # Get some information about the host system
954 SYSTEM_PROCESSORS="$(system_processors)"
955 SYSTEM_MEMORY="$(system_memory)"
956
957 if [ -n "${BUILD_ARCH}" ]; then
958 configure_build "${BUILD_ARCH}"
959 else
960 configure_build "default"
961 fi
962
963 # Automatically enable/disable ramdisk usage
964 if [ "${ENABLE_RAMDISK}" = "auto" ]; then
965 # Enable only when the host system has 4GB of RAM or more
966 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
967 ENABLE_RAMDISK="on"
968 fi
969 fi
970
971 buildtoolchain() {
972 local error=false
973 case "${BUILD_ARCH}:${HOST_ARCH}" in
974 # x86_64
975 x86_64:x86_64)
976 # This is working.
977 ;;
978
979 # x86
980 i586:i586|i586:i686|i586:x86_64)
981 # These are working.
982 ;;
983 i586:*)
984 error=true
985 ;;
986
987 # ARM
988 arvm7hl:armv7hl|armv7hl:armv7l)
989 # These are working.
990 ;;
991
992 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
993 # These are working.
994 ;;
995 armv5tel:*)
996 error=true
997 ;;
998 esac
999
1000 ${error} && \
1001 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
1002
1003 local gcc=$(type -p gcc)
1004 if [ -z "${gcc}" ]; then
1005 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1006 fi
1007
1008 # Check ${TOOLS_DIR} symlink
1009 if [ -h "${TOOLS_DIR}" ]; then
1010 rm -f "${TOOLS_DIR}"
1011 fi
1012
1013 if [ ! -e "${TOOLS_DIR}" ]; then
1014 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1015 fi
1016
1017 if [ ! -h "${TOOLS_DIR}" ]; then
1018 exiterror "Could not create ${TOOLS_DIR} symbolic link"
1019 fi
1020
1021 LOGFILE="$BASEDIR/log/_build.toolchain.log"
1022 export LOGFILE
1023
1024 lfsmake1 stage1
1025 lfsmake1 ccache PASS=1
1026 lfsmake1 binutils PASS=1
1027 lfsmake1 gcc PASS=1
1028 lfsmake1 linux KCFG="-headers"
1029 lfsmake1 glibc
1030 lfsmake1 libxcrypt
1031 lfsmake1 gcc PASS=L
1032 lfsmake1 binutils PASS=2
1033 lfsmake1 gcc PASS=2
1034 lfsmake1 zlib
1035 lfsmake1 ccache PASS=2
1036 lfsmake1 tcl
1037 lfsmake1 expect
1038 lfsmake1 dejagnu
1039 lfsmake1 pkg-config
1040 lfsmake1 ncurses
1041 lfsmake1 bash
1042 lfsmake1 bzip2
1043 lfsmake1 automake
1044 lfsmake1 coreutils
1045 lfsmake1 diffutils
1046 lfsmake1 findutils
1047 lfsmake1 gawk
1048 lfsmake1 gettext
1049 lfsmake1 grep
1050 lfsmake1 gzip
1051 lfsmake1 m4
1052 lfsmake1 make
1053 lfsmake1 patch
1054 lfsmake1 perl
1055 lfsmake1 python3
1056 lfsmake1 sed
1057 lfsmake1 tar
1058 lfsmake1 texinfo
1059 lfsmake1 xz
1060 lfsmake1 bison
1061 lfsmake1 flex
1062 lfsmake1 fake-environ
1063 lfsmake1 strip
1064 lfsmake1 cleanup-toolchain
1065 }
1066
1067 buildbase() {
1068 LOGFILE="$BASEDIR/log/_build.base.log"
1069 export LOGFILE
1070 lfsmake2 stage2
1071 lfsmake2 linux KCFG="-headers"
1072 lfsmake2 man-pages
1073 lfsmake2 glibc
1074 lfsmake2 tzdata
1075 lfsmake2 cleanup-toolchain
1076 lfsmake2 zlib
1077 lfsmake2 zstd
1078 lfsmake2 autoconf
1079 lfsmake2 automake
1080 lfsmake2 libtool
1081 lfsmake2 binutils
1082 lfsmake2 gmp
1083 lfsmake2 mpfr
1084 lfsmake2 libmpc
1085 lfsmake2 libxcrypt
1086 lfsmake2 file
1087 lfsmake2 gcc
1088 lfsmake2 sed
1089 lfsmake2 berkeley
1090 lfsmake2 coreutils
1091 lfsmake2 iana-etc
1092 lfsmake2 m4
1093 lfsmake2 bison
1094 lfsmake2 ncurses
1095 lfsmake2 perl
1096 lfsmake2 readline
1097 lfsmake2 bzip2
1098 lfsmake2 xz
1099 lfsmake2 lzip
1100 lfsmake2 pcre
1101 lfsmake2 pcre2
1102 lfsmake2 gettext
1103 lfsmake2 attr
1104 lfsmake2 acl
1105 lfsmake2 bash
1106 lfsmake2 diffutils
1107 lfsmake2 e2fsprogs
1108 lfsmake2 ed
1109 lfsmake2 findutils
1110 lfsmake2 flex
1111 lfsmake2 gawk
1112 lfsmake2 go
1113 lfsmake2 grep
1114 lfsmake2 groff
1115 lfsmake2 gperf
1116 lfsmake2 gzip
1117 lfsmake2 hostname
1118 lfsmake2 iproute2
1119 lfsmake2 jwhois
1120 lfsmake2 kbd
1121 lfsmake2 less
1122 lfsmake2 pkg-config
1123 lfsmake2 procps
1124 lfsmake2 make
1125 lfsmake2 man
1126 lfsmake2 net-tools
1127 lfsmake2 patch
1128 lfsmake2 psmisc
1129 lfsmake2 shadow
1130 lfsmake2 sysklogd
1131 lfsmake2 sysvinit
1132 lfsmake2 tar
1133 lfsmake2 texinfo
1134 lfsmake2 util-linux
1135 lfsmake2 vim
1136 }
1137
1138 buildipfire() {
1139 LOGFILE="$BASEDIR/log/_build.ipfire.log"
1140 export LOGFILE
1141 lfsmake2 configroot
1142 lfsmake2 initscripts
1143 lfsmake2 backup
1144 lfsmake2 openssl
1145 lfsmake2 kmod
1146 lfsmake2 udev
1147 lfsmake2 popt
1148 lfsmake2 libedit
1149 lfsmake2 libusb
1150 lfsmake2 libusb-compat
1151 lfsmake2 libpcap
1152 lfsmake2 ppp
1153 lfsmake2 pptp
1154 lfsmake2 unzip
1155 lfsmake2 which
1156 lfsmake2 linux-firmware
1157 lfsmake2 dvb-firmwares
1158 lfsmake2 xr819-firmware
1159 lfsmake2 zd1211-firmware
1160 lfsmake2 rpi-firmware
1161 lfsmake2 intel-microcode
1162 lfsmake2 pcengines-apu-firmware
1163 lfsmake2 bc
1164 lfsmake2 u-boot MKIMAGE=1
1165 lfsmake2 cpio
1166 lfsmake2 mdadm
1167 lfsmake2 dracut
1168 lfsmake2 libaio
1169 lfsmake2 lvm2
1170 lfsmake2 multipath-tools
1171 lfsmake2 freetype
1172 lfsmake2 libmnl
1173 lfsmake2 libnfnetlink
1174 lfsmake2 libnetfilter_queue
1175 lfsmake2 libnetfilter_conntrack
1176 lfsmake2 libnetfilter_cthelper
1177 lfsmake2 libnetfilter_cttimeout
1178 lfsmake2 iptables
1179 lfsmake2 screen
1180 lfsmake2 elfutils
1181
1182 case "${BUILD_ARCH}" in
1183 x86_64|aarch64)
1184 lfsmake2 linux KCFG=""
1185 # lfsmake2 backports KCFG=""
1186 # lfsmake2 e1000e KCFG=""
1187 # lfsmake2 igb KCFG=""
1188 # lfsmake2 ixgbe KCFG=""
1189 lfsmake2 xtables-addons KCFG=""
1190 lfsmake2 linux-initrd KCFG=""
1191 ;;
1192 i586)
1193 # x86 kernel build
1194 lfsmake2 linux KCFG=""
1195 # lfsmake2 backports KCFG=""
1196 # lfsmake2 e1000e KCFG=""
1197 # lfsmake2 igb KCFG=""
1198 # lfsmake2 ixgbe KCFG=""
1199 lfsmake2 xtables-addons KCFG=""
1200 lfsmake2 linux-initrd KCFG=""
1201 ;;
1202
1203 armv5tel)
1204 # arm multi platform (Panda, Wandboard ...) kernel build
1205 lfsmake2 linux KCFG="-multi"
1206 # lfsmake2 backports KCFG="-multi"
1207 # lfsmake2 e1000e KCFG="-multi"
1208 # lfsmake2 igb KCFG="-multi"
1209 # lfsmake2 ixgbe KCFG="-multi"
1210 lfsmake2 xtables-addons KCFG="-multi"
1211 lfsmake2 linux-initrd KCFG="-multi"
1212 ;;
1213 esac
1214 lfsmake2 xtables-addons USPACE="1"
1215 lfsmake2 libgpg-error
1216 lfsmake2 libgcrypt
1217 lfsmake2 libassuan
1218 lfsmake2 nettle
1219 lfsmake2 json-c
1220 lfsmake2 libconfig
1221 lfsmake2 libevent
1222 lfsmake2 libevent2
1223 lfsmake2 expat
1224 lfsmake2 apr
1225 lfsmake2 aprutil
1226 lfsmake2 unbound
1227 lfsmake2 gnutls
1228 lfsmake2 bind
1229 lfsmake2 dhcp
1230 lfsmake2 dhcpcd
1231 lfsmake2 boost
1232 lfsmake2 linux-atm
1233 lfsmake2 gdbm
1234 lfsmake2 pam
1235 lfsmake2 c-ares
1236 lfsmake2 curl
1237 lfsmake2 tcl
1238 lfsmake2 sqlite
1239 lfsmake2 libffi
1240 lfsmake2 python
1241 lfsmake2 python3
1242 lfsmake2 gdb
1243 lfsmake2 grub
1244 lfsmake2 efivar
1245 lfsmake2 efibootmgr
1246 lfsmake2 ca-certificates
1247 lfsmake2 fireinfo
1248 lfsmake2 libnet
1249 lfsmake2 libnl
1250 lfsmake2 libnl-3
1251 lfsmake2 libidn
1252 lfsmake2 nasm
1253 lfsmake2 libarchive
1254 lfsmake2 cmake
1255 lfsmake2 ninja
1256 lfsmake2 meson
1257 lfsmake2 libjpeg
1258 lfsmake2 openjpeg
1259 lfsmake2 libexif
1260 lfsmake2 libpng
1261 lfsmake2 libtiff
1262 lfsmake2 libart
1263 lfsmake2 gd
1264 lfsmake2 slang
1265 lfsmake2 newt
1266 lfsmake2 libsmooth
1267 lfsmake2 libcap
1268 lfsmake2 libcap-ng
1269 lfsmake2 pciutils
1270 lfsmake2 usbutils
1271 lfsmake2 libxml2
1272 lfsmake2 libxslt
1273 lfsmake2 BerkeleyDB
1274 lfsmake2 cyrus-sasl
1275 lfsmake2 openldap
1276 lfsmake2 apache2
1277 lfsmake2 web-user-interface
1278 lfsmake2 flag-icons
1279 lfsmake2 jquery
1280 lfsmake2 bootstrap
1281 lfsmake2 arping
1282 lfsmake2 beep
1283 lfsmake2 libssh
1284 lfsmake2 cdrkit
1285 lfsmake2 dosfstools
1286 lfsmake2 reiserfsprogs
1287 lfsmake2 xfsprogs
1288 lfsmake2 sysfsutils
1289 lfsmake2 fuse
1290 lfsmake2 ntfs-3g
1291 lfsmake2 ethtool
1292 lfsmake2 fcron
1293 lfsmake2 perl-GD
1294 lfsmake2 GD-Graph
1295 lfsmake2 GD-TextUtil
1296 lfsmake2 perl-Device-SerialPort
1297 lfsmake2 perl-Device-Modem
1298 lfsmake2 perl-Apache-Htpasswd
1299 lfsmake2 perl-Parse-Yapp
1300 lfsmake2 gnupg
1301 lfsmake2 hdparm
1302 lfsmake2 sdparm
1303 lfsmake2 mtools
1304 lfsmake2 whatmask
1305 lfsmake2 libtirpc
1306 lfsmake2 conntrack-tools
1307 lfsmake2 libupnp
1308 lfsmake2 ipaddr
1309 lfsmake2 iputils
1310 lfsmake2 l7-protocols
1311 lfsmake2 hwdata
1312 lfsmake2 logrotate
1313 lfsmake2 logwatch
1314 lfsmake2 misc-progs
1315 lfsmake2 nano
1316 lfsmake2 URI
1317 lfsmake2 perl-CGI
1318 lfsmake2 perl-Switch
1319 lfsmake2 HTML-Tagset
1320 lfsmake2 HTML-Parser
1321 lfsmake2 HTML-Template
1322 lfsmake2 Compress-Zlib
1323 lfsmake2 Digest
1324 lfsmake2 Digest-SHA1
1325 lfsmake2 Digest-HMAC
1326 lfsmake2 libwww-perl
1327 lfsmake2 Net-DNS
1328 lfsmake2 Net-IPv4Addr
1329 lfsmake2 Net_SSLeay
1330 lfsmake2 IO-Stringy
1331 lfsmake2 IO-Socket-SSL
1332 lfsmake2 Unix-Syslog
1333 lfsmake2 Mail-Tools
1334 lfsmake2 MIME-Tools
1335 lfsmake2 Net-Server
1336 lfsmake2 Convert-TNEF
1337 lfsmake2 Convert-UUlib
1338 lfsmake2 Archive-Tar
1339 lfsmake2 Archive-Zip
1340 lfsmake2 Text-Tabs+Wrap
1341 lfsmake2 XML-Parser
1342 lfsmake2 Crypt-PasswdMD5
1343 lfsmake2 Net-Telnet
1344 lfsmake2 python-setuptools
1345 lfsmake2 python-clientform
1346 lfsmake2 python-mechanize
1347 lfsmake2 python-feedparser
1348 lfsmake2 python-rssdler
1349 lfsmake2 python-inotify
1350 lfsmake2 python-docutils
1351 lfsmake2 python-daemon
1352 lfsmake2 python-ipaddress
1353 lfsmake2 glib
1354 lfsmake2 ntp
1355 lfsmake2 openssh
1356 lfsmake2 fontconfig
1357 lfsmake2 dejavu-fonts-ttf
1358 lfsmake2 ubuntu-font-family
1359 lfsmake2 freefont
1360 lfsmake2 pixman
1361 lfsmake2 cairo
1362 lfsmake2 pango
1363 lfsmake2 rrdtool
1364 lfsmake2 setup
1365 lfsmake2 libdnet
1366 lfsmake2 rust
1367 lfsmake2 jansson
1368 lfsmake2 yaml
1369 lfsmake2 libhtp
1370 lfsmake2 colm
1371 lfsmake2 ragel
1372 lfsmake2 hyperscan
1373 lfsmake2 suricata
1374 lfsmake2 oinkmaster
1375 lfsmake2 ids-ruleset-sources
1376 lfsmake2 squid
1377 lfsmake2 squidguard
1378 lfsmake2 calamaris
1379 lfsmake2 tcpdump
1380 lfsmake2 traceroute
1381 lfsmake2 vlan
1382 lfsmake2 wireless
1383 lfsmake2 pakfire
1384 lfsmake2 spandsp
1385 lfsmake2 lz4
1386 lfsmake2 lzo
1387 lfsmake2 openvpn
1388 lfsmake2 mpage
1389 lfsmake2 dbus
1390 lfsmake2 intltool
1391 lfsmake2 libdaemon
1392 lfsmake2 avahi
1393 lfsmake2 cups
1394 lfsmake2 lcms2
1395 lfsmake2 ghostscript
1396 lfsmake2 qpdf
1397 lfsmake2 poppler
1398 lfsmake2 poppler-data
1399 lfsmake2 cups-filters
1400 lfsmake2 epson-inkjet-printer-escpr
1401 lfsmake2 foomatic
1402 lfsmake2 hplip
1403 lfsmake2 cifs-utils
1404 lfsmake2 krb5
1405 lfsmake2 rpcsvc-proto
1406 lfsmake2 samba
1407 lfsmake2 netatalk
1408 lfsmake2 sudo
1409 lfsmake2 mc
1410 lfsmake2 wget
1411 lfsmake2 bridge-utils
1412 lfsmake2 smartmontools
1413 lfsmake2 htop
1414 lfsmake2 chkconfig
1415 lfsmake2 postfix
1416 lfsmake2 fetchmail
1417 lfsmake2 clamav
1418 lfsmake2 perl-NetAddr-IP
1419 lfsmake2 dma
1420 lfsmake2 alsa
1421 lfsmake2 mpfire
1422 lfsmake2 guardian
1423 lfsmake2 libid3tag
1424 lfsmake2 libmad
1425 lfsmake2 libogg
1426 lfsmake2 libvorbis
1427 lfsmake2 libdvbpsi
1428 lfsmake2 flac
1429 lfsmake2 lame
1430 lfsmake2 sox
1431 lfsmake2 soxr
1432 lfsmake2 libshout
1433 lfsmake2 xvid
1434 lfsmake2 libmpeg2
1435 lfsmake2 gnump3d
1436 lfsmake2 rsync
1437 lfsmake2 rpcbind
1438 lfsmake2 keyutils
1439 lfsmake2 libnfsidmap
1440 lfsmake2 nfs
1441 lfsmake2 gnu-netcat
1442 lfsmake2 ncat
1443 lfsmake2 nmap
1444 lfsmake2 etherwake
1445 lfsmake2 bwm-ng
1446 lfsmake2 sysstat
1447 lfsmake2 strongswan
1448 lfsmake2 rng-tools
1449 lfsmake2 lsof
1450 lfsmake2 br2684ctl
1451 lfsmake2 pcmciautils
1452 lfsmake2 lm_sensors
1453 lfsmake2 liboping
1454 lfsmake2 collectd
1455 lfsmake2 elinks
1456 lfsmake2 igmpproxy
1457 lfsmake2 fbset
1458 lfsmake2 opus
1459 lfsmake2 python-six
1460 lfsmake2 python-pyparsing
1461 lfsmake2 spice-protocol
1462 lfsmake2 spice
1463 lfsmake2 sdl
1464 lfsmake2 libusbredir
1465 lfsmake2 libseccomp
1466 lfsmake2 qemu
1467 lfsmake2 sane
1468 lfsmake2 netpbm
1469 lfsmake2 netsnmpd
1470 lfsmake2 nagios_nrpe
1471 lfsmake2 nagios-plugins
1472 lfsmake2 icinga
1473 lfsmake2 observium-agent
1474 lfsmake2 ebtables
1475 lfsmake2 faad2
1476 lfsmake2 alac
1477 lfsmake2 ffmpeg
1478 lfsmake2 vdr
1479 lfsmake2 vdr_streamdev
1480 lfsmake2 vdr_epgsearch
1481 lfsmake2 vdr_dvbapi
1482 lfsmake2 vdr_eepg
1483 lfsmake2 w_scan
1484 lfsmake2 mpd
1485 lfsmake2 libmpdclient
1486 lfsmake2 mpc
1487 lfsmake2 perl-Net-CIDR-Lite
1488 lfsmake2 perl-Net-SMTP-SSL
1489 lfsmake2 perl-MIME-Base64
1490 lfsmake2 perl-Authen-SASL
1491 lfsmake2 perl-MIME-Lite
1492 lfsmake2 perl-Email-Date-Format
1493 lfsmake2 git
1494 lfsmake2 squidclamav
1495 lfsmake2 vnstat
1496 lfsmake2 iw
1497 lfsmake2 wpa_supplicant
1498 lfsmake2 hostapd
1499 lfsmake2 pycurl
1500 lfsmake2 urlgrabber
1501 lfsmake2 syslinux
1502 lfsmake2 tftpd
1503 lfsmake2 cpufrequtils
1504 lfsmake2 gutenprint
1505 lfsmake2 apcupsd
1506 lfsmake2 fireperf
1507 lfsmake2 iperf
1508 lfsmake2 iperf3
1509 lfsmake2 7zip
1510 lfsmake2 lynis
1511 lfsmake2 sshfs
1512 lfsmake2 taglib
1513 lfsmake2 sslh
1514 lfsmake2 perl-gettext
1515 lfsmake2 perl-Sort-Naturally
1516 lfsmake2 vdradmin
1517 lfsmake2 perl-DBI
1518 lfsmake2 perl-DBD-SQLite
1519 lfsmake2 perl-File-ReadBackwards
1520 lfsmake2 openvmtools
1521 lfsmake2 libmicrohttpd
1522 lfsmake2 motion
1523 lfsmake2 joe
1524 lfsmake2 monit
1525 lfsmake2 nut
1526 lfsmake2 watchdog
1527 lfsmake2 libpri
1528 lfsmake2 libsrtp
1529 lfsmake2 asterisk
1530 lfsmake2 usb_modeswitch
1531 lfsmake2 usb_modeswitch_data
1532 lfsmake2 zerofree
1533 lfsmake2 minicom
1534 lfsmake2 ddrescue
1535 lfsmake2 miniupnpd
1536 lfsmake2 client175
1537 lfsmake2 powertop
1538 lfsmake2 parted
1539 lfsmake2 swig
1540 lfsmake2 u-boot
1541 lfsmake2 u-boot-friendlyarm
1542 lfsmake2 python-typing
1543 lfsmake2 python-m2crypto
1544 lfsmake2 wireless-regdb
1545 lfsmake2 crda
1546 lfsmake2 libsolv
1547 lfsmake2 python-distutils-extra
1548 lfsmake2 python-lzma
1549 lfsmake2 python-progressbar
1550 lfsmake2 ddns
1551 lfsmake2 python3-setuptools
1552 lfsmake2 python3-setuptools-scm
1553 lfsmake2 python3-six
1554 lfsmake2 python3-dateutil
1555 lfsmake2 python3-jmespath
1556 lfsmake2 python3-colorama
1557 lfsmake2 python3-docutils
1558 lfsmake2 python3-yaml
1559 lfsmake2 python3-s3transfer
1560 lfsmake2 python3-rsa
1561 lfsmake2 python3-pyasn1
1562 lfsmake2 python3-urllib3
1563 lfsmake2 python3-botocore
1564 lfsmake2 python3-llfuse
1565 lfsmake2 python3-msgpack
1566 lfsmake2 aws-cli
1567 lfsmake2 transmission
1568 lfsmake2 dpfhack
1569 lfsmake2 lcd4linux
1570 lfsmake2 mtr
1571 lfsmake2 minidlna
1572 lfsmake2 acpid
1573 lfsmake2 fping
1574 lfsmake2 telnet
1575 lfsmake2 xinetd
1576 lfsmake2 gpgme
1577 lfsmake2 pygpgme
1578 lfsmake2 pakfire3
1579 lfsmake2 stress
1580 lfsmake2 libstatgrab
1581 lfsmake2 sarg
1582 lfsmake2 nginx
1583 lfsmake2 sendEmail
1584 lfsmake2 sysbench
1585 lfsmake2 strace
1586 lfsmake2 ltrace
1587 lfsmake2 ipfire-netboot
1588 lfsmake2 lcdproc
1589 lfsmake2 keepalived
1590 lfsmake2 ipvsadm
1591 lfsmake2 perl-Carp-Clan
1592 lfsmake2 perl-Date-Calc
1593 lfsmake2 perl-Date-Manip
1594 lfsmake2 perl-File-Tail
1595 lfsmake2 perl-TimeDate
1596 lfsmake2 swatch
1597 lfsmake2 tor
1598 lfsmake2 wavemon
1599 lfsmake2 iptraf-ng
1600 lfsmake2 iotop
1601 lfsmake2 stunnel
1602 lfsmake2 bacula
1603 lfsmake2 perl-Font-TTF
1604 lfsmake2 perl-IO-String
1605 lfsmake2 perl-PDF-API2
1606 lfsmake2 squid-accounting
1607 lfsmake2 pigz
1608 lfsmake2 tmux
1609 lfsmake2 perl-Text-CSV_XS
1610 lfsmake2 lua
1611 lfsmake2 haproxy
1612 lfsmake2 ipset
1613 lfsmake2 dnsdist
1614 lfsmake2 bird
1615 lfsmake2 frr
1616 lfsmake2 dmidecode
1617 lfsmake2 mcelog
1618 lfsmake2 util-macros
1619 lfsmake2 libpciaccess
1620 lfsmake2 libyajl
1621 lfsmake2 libvirt
1622 lfsmake2 libtalloc
1623 lfsmake2 freeradius
1624 lfsmake2 perl-common-sense
1625 lfsmake2 perl-inotify2
1626 lfsmake2 perl-Net-IP
1627 lfsmake2 wio
1628 lfsmake2 iftop
1629 lfsmake2 mdns-repeater
1630 lfsmake2 i2c-tools
1631 lfsmake2 nss-myhostname
1632 lfsmake2 dehydrated
1633 lfsmake2 shairport-sync
1634 lfsmake2 borgbackup
1635 lfsmake2 lmdb
1636 lfsmake2 knot
1637 lfsmake2 spectre-meltdown-checker
1638 lfsmake2 zabbix_agentd
1639 lfsmake2 flashrom
1640 lfsmake2 firmware-update
1641 lfsmake2 tshark
1642 lfsmake2 speedtest-cli
1643 lfsmake2 rfkill
1644 lfsmake2 amazon-ssm-agent
1645 lfsmake2 libloc
1646 lfsmake2 ncdu
1647 lfsmake2 lshw
1648 lfsmake2 socat
1649 }
1650
1651 buildinstaller() {
1652 # Run installer scripts one by one
1653 LOGFILE="$BASEDIR/log/_build.installer.log"
1654 export LOGFILE
1655 lfsmake2 memtest
1656 lfsmake2 installer
1657 # use toolchain bash for chroot to strip
1658 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
1659 }
1660
1661 buildpackages() {
1662 LOGFILE="$BASEDIR/log/_build.packages.log"
1663 export LOGFILE
1664 echo "... see detailed log in _build.*.log files" >> $LOGFILE
1665
1666
1667 # Generating list of packages used
1668 print_line "Generating packages list from logs"
1669 rm -f $BASEDIR/doc/packages-list
1670 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1671 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
1672 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
1673 fi
1674 done
1675 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
1676 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
1677 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1678 rm -f $BASEDIR/doc/packages-list
1679 # packages-list.txt is ready to be displayed for wiki page
1680 print_status DONE
1681
1682 # Update changelog
1683 cd $BASEDIR
1684 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1685 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1686 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
1687
1688 # Create images for install
1689 lfsmake2 cdrom
1690
1691 # Check if there is a loop device for building in virtual environments
1692 modprobe loop 2>/dev/null
1693 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
1694 lfsmake2 flash-images
1695 fi
1696
1697 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
1698
1699 ipfirepackages
1700
1701 cd $BASEDIR
1702
1703 # remove not useable iso on armv5tel (needed to build flash images)
1704 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
1705
1706 for i in $(ls *.bz2 *.img.xz *.iso 2>/dev/null); do
1707 md5sum $i > $i.md5
1708 done
1709 cd $PWD
1710
1711 # Cleanup
1712 stdumount
1713 rm -rf $BASEDIR/build/tmp/*
1714
1715 cd $PWD
1716 }
1717
1718 ipfirepackages() {
1719 lfsmake2 core-updates
1720
1721 local i
1722 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
1723 i=$(basename ${i})
1724 if [ -e $BASEDIR/lfs/$i ]; then
1725 ipfiredist $i
1726 else
1727 echo -n $i
1728 print_status SKIP
1729 fi
1730 done
1731 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
1732 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
1733 rm -rf $BASEDIR/build/install/packages/*
1734 }
1735
1736 while [ $# -gt 0 ]; do
1737 case "${1}" in
1738 --target=*)
1739 configure_build "${1#--target=}"
1740 ;;
1741 -*)
1742 exiterror "Unknown configuration option: ${1}"
1743 ;;
1744 *)
1745 # Found a command, so exit options parsing.
1746 break
1747 ;;
1748 esac
1749 shift
1750 done
1751
1752 # See what we're supposed to do
1753 case "$1" in
1754 build)
1755 START_TIME=$(now)
1756
1757 # Clear screen
1758 ${INTERACTIVE} && clear
1759
1760 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
1761 #only restore on a clean disk
1762 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
1763 if [ ! -n "$PACKAGE" ]; then
1764 print_build_stage "Full toolchain compilation"
1765 prepareenv
1766 buildtoolchain
1767 else
1768 PACKAGENAME=${PACKAGE%.tar.xz}
1769 print_build_stage "Packaged toolchain compilation"
1770 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
1771 tar axf $PACKAGE
1772 prepareenv
1773 else
1774 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1775 fi
1776 fi
1777 else
1778 prepareenv
1779 fi
1780
1781 print_build_stage "Building LFS"
1782 buildbase
1783
1784 print_build_stage "Building IPFire"
1785 buildipfire
1786
1787 print_build_stage "Building installer"
1788 buildinstaller
1789
1790 print_build_stage "Building packages"
1791 buildpackages
1792
1793 print_build_stage "Checking Logfiles for new Files"
1794
1795 cd $BASEDIR
1796 tools/checknewlog.pl
1797 tools/checkrootfiles
1798 cd $PWD
1799
1800 print_build_summary $(( $(now) - ${START_TIME} ))
1801 ;;
1802 shell)
1803 # enter a shell inside LFS chroot
1804 # may be used to changed kernel settings
1805 prepareenv
1806 entershell
1807 ;;
1808 clean)
1809 print_line "Cleaning build directory..."
1810
1811 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1812 $LOSETUP -d $i 2>/dev/null
1813 done
1814 #for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1815 # umount $i
1816 #done
1817 stdumount
1818 for i in `seq 0 7`; do
1819 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
1820 umount /dev/loop${i} 2>/dev/null;
1821 losetup -d /dev/loop${i} 2>/dev/null;
1822 fi;
1823 done
1824 rm -rf $BASEDIR/build
1825 rm -rf $BASEDIR/cdrom
1826 rm -rf $BASEDIR/packages
1827 rm -rf $BASEDIR/log
1828 if [ -h "${TOOLS_DIR}" ]; then
1829 rm -f "${TOOLS_DIR}"
1830 fi
1831 rm -f $BASEDIR/ipfire-*
1832 print_status DONE
1833 ;;
1834 docker)
1835 # Build the docker image if it does not exist, yet
1836 if ! docker images -a | grep -q ^ipfire-builder; then
1837 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1838 print_status DONE
1839 else
1840 print_status FAIL
1841 exit 1
1842 fi
1843 fi
1844
1845 # Run the container and enter a shell
1846 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1847 ;;
1848 downloadsrc)
1849 if [ ! -d $BASEDIR/cache ]; then
1850 mkdir $BASEDIR/cache
1851 fi
1852 mkdir -p $BASEDIR/log
1853 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
1854 FINISHED=0
1855 cd $BASEDIR/lfs
1856 for c in `seq $MAX_RETRIES`; do
1857 if (( FINISHED==1 )); then
1858 break
1859 fi
1860 FINISHED=1
1861 cd $BASEDIR/lfs
1862 for i in *; do
1863 if [ -f "$i" -a "$i" != "Config" ]; then
1864 lfsmakecommoncheck ${i} || continue
1865
1866 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1867 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
1868 if [ $? -ne 0 ]; then
1869 print_status FAIL
1870 FINISHED=0
1871 else
1872 if [ $c -eq 1 ]; then
1873 print_status DONE
1874 fi
1875 fi
1876 fi
1877 done
1878 done
1879 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
1880 ERROR=0
1881 for i in *; do
1882 if [ -f "$i" -a "$i" != "Config" ]; then
1883 lfsmakecommoncheck ${i} > /dev/null || continue
1884 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1885 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
1886 if [ $? -ne 0 ]; then
1887 echo -ne "MD5 difference in lfs/$i"
1888 print_status FAIL
1889 ERROR=1
1890 fi
1891 fi
1892 done
1893 if [ $ERROR -eq 0 ]; then
1894 echo -ne "${BOLD}all files md5sum match${NORMAL}"
1895 print_status DONE
1896 else
1897 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
1898 print_status FAIL
1899 fi
1900 cd - >/dev/null 2>&1
1901 ;;
1902 toolchain)
1903 # Clear screen
1904 ${INTERACTIVE} && clear
1905
1906 prepareenv
1907 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
1908 buildtoolchain
1909 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1910 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1911 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log | xz ${XZ_OPT} \
1912 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz
1913 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
1914 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
1915 stdumount
1916 ;;
1917 gettoolchain)
1918 # arbitrary name to be updated in case of new toolchain package upload
1919 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
1920 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
1921 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
1922 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1923 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1924 cd $BASEDIR/cache/toolchains
1925 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
1926 if [ $? -ne 0 ]; then
1927 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
1928 else
1929 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
1930 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1931 else
1932 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1933 fi
1934 fi
1935 else
1936 echo "Toolchain is already downloaded. Exiting..."
1937 fi
1938 ;;
1939 uploadsrc)
1940 PWD=`pwd`
1941 if [ -z $IPFIRE_USER ]; then
1942 echo -n "You have to setup IPFIRE_USER first. See .config for details."
1943 print_status FAIL
1944 exit 1
1945 fi
1946
1947 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
1948 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
1949
1950 for file in ${BASEDIR}/cache/*; do
1951 [ -d "${file}" ] && continue
1952 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
1953 NEW_FILES="$NEW_FILES $file"
1954 done
1955 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1956 cd $BASEDIR
1957 cd $PWD
1958 exit 0
1959 ;;
1960 lang)
1961 echo -ne "Checking the translations for missing or obsolete strings..."
1962 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1963 $BASEDIR/tools/sort_strings.pl en
1964 $BASEDIR/tools/sort_strings.pl de
1965 $BASEDIR/tools/sort_strings.pl fr
1966 $BASEDIR/tools/sort_strings.pl es
1967 $BASEDIR/tools/sort_strings.pl pl
1968 $BASEDIR/tools/sort_strings.pl ru
1969 $BASEDIR/tools/sort_strings.pl nl
1970 $BASEDIR/tools/sort_strings.pl tr
1971 $BASEDIR/tools/sort_strings.pl it
1972 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1973 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1974 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1975 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1976 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1977 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1978 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1979 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1980 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1981 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
1982 print_status DONE
1983
1984 echo -ne "Updating language lists..."
1985 update_language_list ${BASEDIR}/src/installer/po
1986 update_language_list ${BASEDIR}/src/setup/po
1987 print_status DONE
1988 ;;
1989 update-contributors)
1990 update_contributors
1991 ;;
1992 find-dependencies)
1993 shift
1994 exec "${BASEDIR}/tools/find-dependencies" "${BASEDIR}/build" "$@"
1995 ;;
1996 *)
1997 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors|find-dependencies}"
1998 cat doc/make.sh-usage
1999 ;;
2000 esac
2001